=== src/parser/CMakeLists.txt ===

add_library (parser OBJECT
    arg_list.cc
    arg_list.h
    parser.cc
    parser.h
    parse_conf.cc
    parse_conf.h
    parse_ip.cc
    parse_ip.h
    parse_ports.cc
    parse_ports.h
    parse_rule.cc
    parse_rule.h
    parse_so_rule.cc
    parse_so_rule.h
    parse_stream.cc
    parse_stream.h
    parse_utils.cc
    parse_utils.h
    cmd_line.cc
    cmd_line.h
    config_file.cc
    config_file.h
    var_dependency.cc
    var_dependency.h
    vars.cc
    vars.h
)
