=== debian/changelog ===
snort (3.9.7.0-0kali2) kali-dev; urgency=medium

  * Tighten libdaq3 dependency

 -- Arnaud Rebillout <arnaudr@kali.org>  Thu, 20 Nov 2025 09:57:15 +0700

snort (3.9.7.0-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * d/watch: Update to use github tags instead of snort download page.
  * d/upstream: Add upstream metadata

  [ Arnaud Rebillout ]
  * Drop mention of armel in debian/rules
  * New upstream version 3.9.7.0
  * Refesh DAQ patch
  * Build-depend on pcre2 instead of pcre3
  * Minor update of lintian overrides

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 19 Nov 2025 18:26:40 +0700
