=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# Enable all hardening features as Snort is a network "listener" of sorts
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ 

override_dh_auto_test-indep:
